#include "math.h"
#include "runlength.h"

int soma_quadrados(IMAGEM *img_original, IMAGEM *img_rotacionada){
	int i, j, h, w, hr, wr, temp;
	int retorno;

	h = img_original->height;
	w = img_original->width;
	hr = img_rotacionada->height;
	wr = img_rotacionada->width;
	retorno = 0;

	for(j = 0; j < h; j++){
		for(i = 0; i < w; i++){
			if(j < hr && i < wr){
				if(img_original->pixels[j][i] == PRETO){
					if(img_rotacionada->pixels[j][i] == PRETO){
						temp = 0;
					}
					else{
						temp = 1;
					}
				}
				else{
					if(img_rotacionada->pixels[j][i] == PRETO){
						temp = -1;
					}
					else{
						temp = 0;
					}
				}
				retorno = retorno + (temp*temp);
			}
		}
	}
	return retorno;
}

void PSNR_Analysis(IMAGEM *img_original, IMAGEM *img_rotacionada){
	double N, M, soma, log, psnr, div, mult, raiz;

	N = (double)img_original->width;
	M = (double)img_original->height;

	soma = (double)soma_quadrados(img_original, img_rotacionada);
	printf("soma = %6.3lf \n", soma);
	mult = N*M;
	printf("mult = %6.3lf \n", mult);
	div = soma/mult;
	printf("div = %6.3lf \n", div);
	raiz = sqrt(div);
	printf("raiz = %6.3lf \n", raiz);
	log = log10(255/raiz);
	printf("log = %6.3lf \n", log);
	psnr = 20*log;

	printf("----------------------------------------\n");
	printf("PSNR = %6.3lf \n", psnr);//ver pq isso!
	printf("----------------------------------------\n");
}
