#include "math.h"
#include "runlength.h"


void plotpointrun(int x, int y, IMAGEM *imagem){
	//int w;

	//w = imagem->width;

	imagem->rotacionado[y][x] = PRETO;
}

void desenhar_reta(PONTO origem, PONTO destino, IMAGEM *imagem, int duas){
	int i, j;
	double m, n,x1, y1, x2, y2;

	x1 = (double)origem.x;
	y1 = (double)origem.y;
	x2 = (double)destino.x;
	y2 = (double)destino.y;

	plotpointrun(x1, y1, imagem);
	plotpointrun(x2, y2, imagem);

	if(x1 != x2){
		m = (y1-y2)/(x1-x2);
		n = y2-(m*x2);
		if(abs(y1-y2)<abs(x1-x2)){
			for(i = min(x1, x2); i <= max(x2, x1); i++){
				j = round((m*(double)i)+n);
				plotpointrun(i, j, imagem);
				if(duas){
					plotpointrun(i, j+1, imagem);
				}
			}
		}
		else{
			for(i = min(y1, y2); i <= max(y2, y1); i++){
				j = round(((double)i-n)/m);
				plotpointrun(j, i, imagem);
				if(duas){
					plotpointrun(j, i+1, imagem);
				}
			}
		}
	}
	else{
		for(i = min(y1, y2);i <= max(y2, y1);i++){
			plotpointrun(x1, i, imagem);
			if(duas){
				plotpointrun(x1, i+1, imagem);
			}
		}
	}
}

#define rotacionar_classico_ponto(p, r)											\
	r.x = (int)round((p.x - w / 2) * cosseno - (p.y - h / 2) * seno + w / 2);	\
	r.y = (int)round((p.y - h / 2) * cosseno + (p.x - w / 2) * seno + h / 2);

void
FastRotationRunBlack(IMAGEM *imagem, double angulo)
{
	register int w, h, esquerda, direita, superior, inferior, novo_width, novo_height, x, y, xx, yy;
	//unsigned char *pixels, *pix;
	PONTO ponto_esquerdo_rotacionado, ponto_direito_rotacionado, ponto_superior_rotacionado, ponto_inferior_rotacionado,
	      ponto_esquerdo_original, ponto_direito_original, ponto_superior_original, ponto_inferior_original, ponto, pr, pir;
	double angulo_total, cosseno, seno;

	w = imagem->width;
	h = imagem->height;

	//pixels = malloc(sizeof(unsigned char) * w * h);
	//memcpy(pixels, imagem->pixels, sizeof(unsigned char) * w * h);

	angulo_total = DEG2RAD(-angulo);
	cosseno = cos(angulo_total);
	seno = sin(angulo_total);

	ponto_esquerdo_original.x = 0;
	ponto_esquerdo_original.y = 0;

	ponto_direito_original.x = w-1;
	ponto_direito_original.y = 0;

	ponto_superior_original.x = 0;
	ponto_superior_original.y = h-1;

	ponto_inferior_original.x = w-1;
	ponto_inferior_original.y = h-1;

	rotacionar_classico_ponto(ponto_esquerdo_original, ponto_esquerdo_rotacionado);
	rotacionar_classico_ponto(ponto_direito_original , ponto_direito_rotacionado );
	rotacionar_classico_ponto(ponto_superior_original, ponto_superior_rotacionado);
	rotacionar_classico_ponto(ponto_inferior_original, ponto_inferior_rotacionado);

	esquerda = MIN(ponto_esquerdo_rotacionado.x,
				   ponto_direito_rotacionado.x,
				   ponto_superior_rotacionado.x,
				   ponto_inferior_rotacionado.x);

	direita = MAX(ponto_esquerdo_rotacionado.x,
				  ponto_direito_rotacionado.x,
				  ponto_superior_rotacionado.x,
				  ponto_inferior_rotacionado.x);

	superior = MIN(ponto_esquerdo_rotacionado.y,
				   ponto_direito_rotacionado.y,
				   ponto_superior_rotacionado.y,
				   ponto_inferior_rotacionado.y);

	inferior = MAX(ponto_esquerdo_rotacionado.y,
	 			   ponto_direito_rotacionado.y,
				   ponto_superior_rotacionado.y,
                   ponto_inferior_rotacionado.y);

	novo_width  = direita  - esquerda + 1;
	novo_height = inferior - superior + 1;

	//free(imagem->pixels);
	//imagem->pixels = (unsigned char *)calloc(novo_width * novo_height, sizeof(unsigned char));
	imagem->width  = novo_width;
	imagem->height = novo_height;
	imagem->rotacionado = calloc(novo_height, sizeof(unsigned char *));
	for(y = 0; y < novo_height; y++){
		imagem->rotacionado[y] = calloc(novo_width, sizeof(unsigned char));
	}
	//pix = imagem->pixels;

	for(y = 0; y < h; y++){
		for(x = 0; x < w; x++){
			if(imagem->pixels[y][x] == PRETO){
				xx = x;//guarda a posicao inicial de x
				yy = y;//guarda a posicao inicial de y
				if(y+1 < h){
					if(imagem->pixels[(y+1)][x]==PRETO){
						while(x+1<w && imagem->pixels[y][(x+1)]==PRETO && imagem->pixels[(y+1)][x+1]==PRETO){
							x++;
						}
						ponto.x = x;
						ponto.y = y;
						rotacionar_classico_ponto(ponto, pr);
						pr.x -= esquerda;
						pr.y -= superior;
						ponto.x = xx;
						ponto.y = yy;
						rotacionar_classico_ponto(ponto, pir);
						pir.x -= esquerda;
						pir.y -= superior;
						desenhar_reta(pir, pr, imagem, 1);
						//retacomdois
						//mandar ja rotacionado!
					}
					else{
						while(x+1<w && imagem->pixels[y][(x+1)]==PRETO && !(imagem->pixels[(y+1)][x+1]==PRETO)){
							x++;
						}
						ponto.x = x;
						ponto.y = y;
						rotacionar_classico_ponto(ponto, pr);
						pr.x -= esquerda;
						pr.y -= superior;
						ponto.x = xx;
						ponto.y = yy;
						rotacionar_classico_ponto(ponto, pir);
						pir.x -= esquerda;
						pir.y -= superior;
						desenhar_reta(pir, pr, imagem, 0);
						//retasemdois
						//mandar ja rotacionado!
					}
				}
				else{
					while(x+1<w && imagem->pixels[y][(x+1)]==PRETO){
						x++;
					}
					ponto.x = x;
					ponto.y = y;
					rotacionar_classico_ponto(ponto, pr);
					pr.x -= esquerda;
					pr.y -= superior;
					ponto.x = xx;
					ponto.y = yy;
					rotacionar_classico_ponto(ponto, pir);
					pir.x -= esquerda;
					pir.y -= superior;
					desenhar_reta(pir, pr, imagem, 0);
					//retasemdois
					//mandar ja rotacionado!
				}
			}
		}
	}
}