#include "math.h"
#include "runlength.h"

#define rotacionar_classico(p, r){										\
	r.x = (int)round((p.x - w / 2) * cosseno - (p.y - h / 2) * seno + w / 2);	\
	r.y = (int)round((p.y - h / 2) * cosseno + (p.x - w / 2) * seno + h / 2);	\
}

void
RotacionarClassico(IMAGEM *imagem, double angulo)
{
	register int w, h, esquerda, direita, superior, inferior, novo_width, novo_height, x, y;
	PONTO ponto_esquerdo_rotacionado, ponto_direito_rotacionado, ponto_superior_rotacionado, ponto_inferior_rotacionado,
	      ponto_esquerdo_original, ponto_direito_original, ponto_superior_original, ponto_inferior_original, ponto, p;
	double angulo_total, cosseno, seno;

	w = imagem->width;
	h = imagem->height;

	angulo_total = DEG2RAD(-angulo);
	cosseno = cos(angulo_total);
	seno = sin(angulo_total);

	ponto_esquerdo_original.x = 0;
	ponto_esquerdo_original.y = 0;

	ponto_direito_original.x = w-1;
	ponto_direito_original.y = 0;

	ponto_superior_original.x = 0;
	ponto_superior_original.y = h-1;

	ponto_inferior_original.x = w-1;
	ponto_inferior_original.y = h-1;

	rotacionar_classico(ponto_esquerdo_original, ponto_esquerdo_rotacionado);
	rotacionar_classico(ponto_direito_original , ponto_direito_rotacionado );
	rotacionar_classico(ponto_superior_original, ponto_superior_rotacionado);
	rotacionar_classico(ponto_inferior_original, ponto_inferior_rotacionado);

	#define MIN(a,b,c,d) min(min(min(a,b),c),d);

	#define MAX(a,b,c,d) max(max(max(a,b),c),d);


	esquerda = MIN(ponto_esquerdo_rotacionado.x,
				   ponto_direito_rotacionado.x,
				   ponto_superior_rotacionado.x,
				   ponto_inferior_rotacionado.x);

	direita = MAX(ponto_esquerdo_rotacionado.x,
				  ponto_direito_rotacionado.x,
				  ponto_superior_rotacionado.x,
				  ponto_inferior_rotacionado.x);

	superior = MIN(ponto_esquerdo_rotacionado.y,
				   ponto_direito_rotacionado.y,
				   ponto_superior_rotacionado.y,
				   ponto_inferior_rotacionado.y);

	inferior = MAX(ponto_esquerdo_rotacionado.y,
	 			   ponto_direito_rotacionado.y,
				   ponto_superior_rotacionado.y,
                   ponto_inferior_rotacionado.y);

	novo_width  = direita  - esquerda + 1;
	novo_height = inferior - superior + 1;
	imagem->width  = novo_width;
	imagem->height = novo_height;
	imagem->rotacionado = calloc(novo_height, sizeof(unsigned char *));
	for(y = 0; y < novo_height; y++){
              imagem->rotacionado[y] = calloc(novo_width, sizeof(unsigned char)); 
        }
	for (y = 0; y < h; y++){
		for (x = 0; x < w; x++){ 			
			if (imagem->pixels[y][x] == PRETO)
		  	{
				ponto.x = x;
				ponto.y = y;
				rotacionar_classico(ponto, p);
				p.x -= esquerda;
				p.y -= superior;
				imagem->rotacionado[p.y][p.x] = PRETO;
			}
		}  		
	}
}
