#include "runlength.h"
#include "math.h"           

int pai(CLASSE *classes, int classe)
{
	if (classes[classe].parent == 0)
		return classe;
	else {
		int pai1 = pai(classes, classes[classe].parent);
		classes[classe].parent = pai1;
		return pai1;
	}
}

void union_find(CLASSE *classes, int classe1, int classe2)
{
	int pai1 = pai(classes, classe1);
	int pai2 = pai(classes, classe2);

	if (pai1 != pai2)
		classes[pai2].parent = pai1;
}

double round(double x)
{
	double y, r;
	y = floor(x);
	r = x - y;
	if (r >= 0.5)
		y += 1;
	return y;
}

#define rotacionar_classico_ponto(p, r){										\
	r.x = (int)round((p.x - w / 2) * cosseno - (p.y - h / 2) * seno + w / 2);	\
	r.y = (int)round((p.y - h / 2) * cosseno + (p.x - w / 2) * seno + h / 2);	\
}

IMAGEM *Abrir(LPSTR lpFileName, double angulo)
{
	IMAGEM *imagem;
	uint16 photo;
	int i, x, y, temp;
	unsigned char *buffer, tempByte;
  	unsigned long count, size;

  	//acrescentei
  	register int w, h, esquerda, direita, superior, inferior, novo_width, novo_height;
	PONTO ponto_esquerdo_rotacionado, ponto_direito_rotacionado, ponto_superior_rotacionado, ponto_inferior_rotacionado,
	      ponto_esquerdo_original, ponto_direito_original, ponto_superior_original, ponto_inferior_original, ponto, p;
	double angulo_total, cosseno, seno;
	//ate aqui

	imagem = (IMAGEM *)malloc(sizeof(IMAGEM));
	imagem->width    = 0;
	imagem->height   = 0;
	imagem->id       = NULL;
	imagem->tif      = TIFFOpen(lpFileName, "r");
	imagem->blocos   = NULL;
	imagem->total_blocos = 0;
	//imagem->rotacionado = (unsigned char*)calloc(3000*4, sizeof(unsigned char));


	if (imagem->tif)
	{
		TIFFGetField(imagem->tif, TIFFTAG_IMAGEWIDTH, &imagem->width);
		TIFFGetField(imagem->tif, TIFFTAG_IMAGELENGTH, &imagem->height);
		TIFFGetField(imagem->tif, TIFFTAG_PHOTOMETRIC, &photo);

		if (imagem->width > 0 && imagem->height > 0)
		{
			//acrescentei aqui
			w = imagem->width*2;
			h = imagem->height*2;

			angulo_total = DEG2RAD(-angulo);
			cosseno = cos(angulo_total);
			seno = sin(angulo_total);

			ponto_esquerdo_original.x = 0;
			ponto_esquerdo_original.y = 0;

			ponto_direito_original.x = w-1;
			ponto_direito_original.y = 0;

			ponto_superior_original.x = 0;
			ponto_superior_original.y = h-1;

			ponto_inferior_original.x = w-1;
			ponto_inferior_original.y = h-1;

			rotacionar_classico_ponto(ponto_esquerdo_original, ponto_esquerdo_rotacionado);
			rotacionar_classico_ponto(ponto_direito_original , ponto_direito_rotacionado );
			rotacionar_classico_ponto(ponto_superior_original, ponto_superior_rotacionado);
			rotacionar_classico_ponto(ponto_inferior_original, ponto_inferior_rotacionado);

			esquerda = MIN(ponto_esquerdo_rotacionado.x,
						   ponto_direito_rotacionado.x,
						   ponto_superior_rotacionado.x,
						   ponto_inferior_rotacionado.x);

			direita = MAX(ponto_esquerdo_rotacionado.x,
						  ponto_direito_rotacionado.x,
						  ponto_superior_rotacionado.x,
						  ponto_inferior_rotacionado.x);

			superior = MIN(ponto_esquerdo_rotacionado.y,
						   ponto_direito_rotacionado.y,
						   ponto_superior_rotacionado.y,
						   ponto_inferior_rotacionado.y);

			inferior = MAX(ponto_esquerdo_rotacionado.y,
			 			   ponto_direito_rotacionado.y,
						   ponto_superior_rotacionado.y,
			               ponto_inferior_rotacionado.y);

			novo_width  = direita  - esquerda + 1;
			novo_height = inferior - superior + 1;

			imagem->pixels = calloc(novo_height, sizeof(unsigned char *));
			for(y = 0; y < novo_height; y++){
				imagem->pixels[y] = calloc(novo_width, sizeof(unsigned char));
			}

			size = TIFFScanlineSize(imagem->tif);
			buffer = (unsigned char *) malloc(size);
			for (y = 0; y < imagem->height; y++)
			{
				//imagem->pixels[y] = calloc(novo_width, sizeof(unsigned char));
				TIFFReadScanline(imagem->tif, buffer, y, 0);
				x = 0;
				for (count = 0; count < size; count++)
				{
					if (photo == PHOTOMETRIC_MINISWHITE)
						tempByte = buffer[count];
					else
				 	    tempByte = ~buffer[count];
					for (i = 7; i >= 0; i--)
					{
						if (x >= imagem->width)	break;
						else
						{
							temp = (tempByte >> i) & 1;
							if(temp == PRETO){
								//marca o 1
								ponto.x = x*2;
								ponto.y = y*2;
								rotacionar_classico_ponto(ponto, p);
								p.x -= esquerda;
								p.y -= superior;
								imagem->pixels[p.y][p.x] = PRETO;
								//marca o 2
								ponto.x = ponto.x + 1;
								rotacionar_classico_ponto(ponto, p);
								p.x -= esquerda;
								p.y -= superior;
								imagem->pixels[p.y][p.x] = PRETO;
								//marcar o 3
								ponto.y = ponto.y + 1;
								rotacionar_classico_ponto(ponto, p);
								p.x -= esquerda;
								p.y -= superior;
								imagem->pixels[p.y][p.x] = PRETO;
								//marcar o 4
								ponto.x = ponto.x - 1;
								rotacionar_classico_ponto(ponto, p);
								p.x -= esquerda;
								p.y -= superior;
								imagem->pixels[p.y][p.x] = PRETO;
							}
							x++;
						}
					}
				}
			}
			// Desaloca memria do buffer.
			free(buffer);
		}
	}
	imagem->width = novo_width;
	imagem->height = novo_height;
	return imagem;
}

/*IMAGEM *Abrir2(LPSTR lpFileName){
	IMAGEM *imagem;
	uint16 photo;
	int i, x, y;
	unsigned char *buffer, tempByte;
	unsigned long count, size;

	imagem = (IMAGEM *)malloc(sizeof(IMAGEM));
	imagem->width    = 0;
	imagem->height   = 0;
	//imagem->pixels   = NULL;
	imagem->id       = NULL;
	imagem->tif      = TIFFOpen(lpFileName, "r");
	imagem->blocos   = NULL;
	imagem->total_blocos = 0;

	if (imagem->tif)
	{
		TIFFGetField(imagem->tif, TIFFTAG_IMAGEWIDTH, &imagem->width);
		TIFFGetField(imagem->tif, TIFFTAG_IMAGELENGTH, &imagem->height);
		TIFFGetField(imagem->tif, TIFFTAG_PHOTOMETRIC, &photo);

		if (imagem->width > 0 && imagem->height > 0)
		{
			// Aloca memria.
			imagem->pixels = (unsigned char *)calloc(imagem->width*imagem->height, sizeof(unsigned char));
			AbrirAux(lpFileName, imagem);
		}
	}
	return imagem;
}*/

IMAGEM *Abrir2(LPSTR lpFileName)
{
	IMAGEM *imagem;
	uint16 photo;
	int i, x, y;
	unsigned char *buffer, tempByte;
  	unsigned long count, size;

	imagem = (IMAGEM *)malloc(sizeof(IMAGEM));
	imagem->width    = 0;
	imagem->height   = 0;
	//imagem->pixels   = NULL;
	imagem->id       = NULL;
	imagem->tif      = TIFFOpen(lpFileName, "r");
	imagem->blocos   = NULL;
	imagem->total_blocos = 0;

	if (imagem->tif)
	{
		TIFFGetField(imagem->tif, TIFFTAG_IMAGEWIDTH, &imagem->width);
		TIFFGetField(imagem->tif, TIFFTAG_IMAGELENGTH, &imagem->height);
		TIFFGetField(imagem->tif, TIFFTAG_PHOTOMETRIC, &photo);

		if (imagem->width > 0 && imagem->height > 0)
		{
			// Aloca memria.
			imagem->pixels = calloc(imagem->height, sizeof(unsigned char *));
			for(y = 0; y < imagem->height; y++){
				imagem->pixels[y] = (unsigned char *)calloc(imagem->width, sizeof(unsigned char));
			}

			// L a imagem.
			//p = imagem->pixels;

			size = TIFFScanlineSize(imagem->tif);
			buffer = (unsigned char *) malloc(size);
			for (y = 0; y < imagem->height; y++)
			{
				TIFFReadScanline(imagem->tif, buffer, y, 0);
				x = 0;
				for (count = 0; count < size; count++)
				{
					if (photo == PHOTOMETRIC_MINISWHITE)
						tempByte = buffer[count];
					else
				 	    tempByte = ~buffer[count];
					for (i = 7; i >= 0; i--)
					{
						if (x >= imagem->width)	break;
						else
						{
							imagem->pixels[y][x] = (tempByte >> i) & 1;
							x++;
						}
					}
				}
			}

			// Desaloca memria do buffer.
			free(buffer);
		}
	}
	return imagem;
}

void Fechar(IMAGEM *imagem, int fechar_tif)
{
	if (imagem->pixels != NULL)
		free(imagem->pixels);

	if (imagem->rotacionado != NULL)
		free(imagem->rotacionado);

	if (imagem->id != NULL)
		free(imagem->id);

	if (imagem->blocos != NULL)
		free(imagem->blocos);

	if (fechar_tif)
		TIFFClose(imagem->tif);

	free(imagem);
	imagem = NULL;
}

void Salvar(IMAGEM *imagem, LPSTR lpFileName)
{
	int x, y;
	TIFF *dst;
	unsigned char *r, *p;

	r = (unsigned char *)malloc(imagem->width*imagem->height);
	p = r;
	
	for (y = 0; y < imagem->height; y++)
		for (x = 0; x <= ((imagem->width-1) | 7); x++)
	    {
			*p <<= 1;
	 		if (x < imagem->width)
	  	  	    *p |= imagem->rotacionado[y][x] & 1;
	  		if ((x & 7) == 7)
	  	  		++p;
		}

	dst = TIFFOpen(lpFileName, "w");

	TIFFSetField(dst, TIFFTAG_IMAGEWIDTH, imagem->width);
	TIFFSetField(dst, TIFFTAG_IMAGELENGTH, imagem->height);
	TIFFSetField(dst, TIFFTAG_BITSPERSAMPLE, 1);
	TIFFSetField(dst, TIFFTAG_SAMPLESPERPIXEL, 1);
	TIFFSetField(dst, TIFFTAG_ROWSPERSTRIP, imagem->height);

	TIFFSetField(dst, TIFFTAG_COMPRESSION, COMPRESSION_CCITTFAX4);
	TIFFSetField(dst, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISWHITE);
	TIFFSetField(dst, TIFFTAG_FILLORDER, FILLORDER_MSB2LSB);
	TIFFSetField(dst, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);

	TIFFSetField(dst, TIFFTAG_XRESOLUTION, 300.0);
	TIFFSetField(dst, TIFFTAG_YRESOLUTION, 300.0);
	TIFFSetField(dst, TIFFTAG_RESOLUTIONUNIT, RESUNIT_NONE);

	TIFFWriteEncodedStrip(dst, 0, r, (imagem->width-1) * (imagem->height-1));

	TIFFClose(dst);

	free(r);
}

/*void Salvar2(IMAGEM *imagem, LPSTR lpFileName, int y_sup, int y_inf, int x_esq, int x_dir)
{
	int x, y;
		TIFF *dst;
		unsigned char *r, *p;

		r = (unsigned char *)malloc(imagem->width*imagem->height);
		p = r;

		for (y = 0; y < imagem->height; y++)
			for (x = 0; x <= ((imagem->width-1) | 7); x++)
		    {
				*p <<= 1;
		 		if (x < imagem->width)
		  	  	    //*p |= *(imagem->pixels + imagem->width*y+x) & 1;
		  	  	    *p |= imagem->pixels[y][x] & 1;
		  		if ((x & 7) == 7)
		  	  		++p;
			}

		dst = TIFFOpen(lpFileName, "w");

		TIFFSetField(dst, TIFFTAG_IMAGEWIDTH, imagem->width);
		TIFFSetField(dst, TIFFTAG_IMAGELENGTH, imagem->height);
		TIFFSetField(dst, TIFFTAG_BITSPERSAMPLE, 1);
		TIFFSetField(dst, TIFFTAG_SAMPLESPERPIXEL, 1);
		TIFFSetField(dst, TIFFTAG_ROWSPERSTRIP, imagem->height);

		TIFFSetField(dst, TIFFTAG_COMPRESSION, COMPRESSION_CCITTFAX4);
		TIFFSetField(dst, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISWHITE);
		TIFFSetField(dst, TIFFTAG_FILLORDER, FILLORDER_MSB2LSB);
		TIFFSetField(dst, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);

		TIFFSetField(dst, TIFFTAG_XRESOLUTION, 200.0);
		TIFFSetField(dst, TIFFTAG_YRESOLUTION, 200.0);
		TIFFSetField(dst, TIFFTAG_RESOLUTIONUNIT, RESUNIT_NONE);

		TIFFWriteEncodedStrip(dst, 0, r, (imagem->width-1) * (imagem->height-1));

		TIFFClose(dst);

	free(r);
}*/

/*void Salvar(IMAGEM *imagem, LPSTR lpFileName)
{
	int x, y;
	TIFF *dst;
	unsigned char *r, *p;

	r = (unsigned char *)malloc(imagem->width*imagem->height);
	p = r;

	for (y = 0; y < imagem->height; y++)
		for (x = 0; x <= ((imagem->width-1) | 7); x++)
	    {
			*p <<= 1;
	 		if (x < imagem->width)
	  	  	    //*p |= *(imagem->pixels + imagem->width*y+x) & 1;
	  	  	    *p |= imagem->pixels[y][x] & 1;
	  		if ((x & 7) == 7)
	  	  		++p;
		}

	dst = TIFFOpen(lpFileName, "w");

	TIFFSetField(dst, TIFFTAG_IMAGEWIDTH, imagem->width);
	TIFFSetField(dst, TIFFTAG_IMAGELENGTH, imagem->height);
	TIFFSetField(dst, TIFFTAG_BITSPERSAMPLE, 1);
	TIFFSetField(dst, TIFFTAG_SAMPLESPERPIXEL, 1);
	TIFFSetField(dst, TIFFTAG_ROWSPERSTRIP, imagem->height);

	TIFFSetField(dst, TIFFTAG_COMPRESSION, COMPRESSION_CCITTFAX4);
	TIFFSetField(dst, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISWHITE);
	TIFFSetField(dst, TIFFTAG_FILLORDER, FILLORDER_MSB2LSB);
	TIFFSetField(dst, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);

	TIFFSetField(dst, TIFFTAG_XRESOLUTION, 200.0);
	TIFFSetField(dst, TIFFTAG_YRESOLUTION, 200.0);
	TIFFSetField(dst, TIFFTAG_RESOLUTIONUNIT, RESUNIT_NONE);

	TIFFWriteEncodedStrip(dst, 0, r, (imagem->width-1) * (imagem->height-1));

	TIFFClose(dst);

	free(r);
}*/
