/*****************************************************************************/
/*                                                                           */
/* NOME DO ARQUIVO:                                                          */
/*    runlength.h                                                            */
/*                                                                           */
/* DESCRIO:                                                                */
/*    Contm todas as definies de constantes, dados e estruturas de dados  */
/*    utilizados na biblioteca. Possui as declaraes dos procedimentos ex-  */
/*    portados para a dll.                                                   */
/*                                                                           */
/* LTIMA MODIFICAO:                                                       */
/*    19/07/2003                                                             */
/*                                                                           */
/*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "..\libtiff\tiffio.h"

/*****************************************************************************/
/*                                                                           */
/* DESCRIO:                                                                */
/*    Definio das cores                                                    */
/*                                                                           */
/*****************************************************************************/


#define MAX_WIDTH (int) 3000 /* tamanho maximo permitido */
#define MAX_HEIGHT (int) 3000

#define BRANCO       (unsigned char) 0
#define PRETO        (unsigned char) 1

#define  PI   3.1415926535897932384626433832795

#define RAD2DEG(a) a * 180 / PI
#define DEG2RAD(a) a * PI / 180

#define MIN(a,b,c,d) min(min(min(a, b), c), d)
#define MAX(a,b,c,d) max(max(max(a, b), c), d)

/*****************************************************************************/
/*                                                                           */
/* DESCRIO:                                                                */
/*    Definio das estruturas de dados.                                     */
/*                                                                           */
/*****************************************************************************/

typedef struct classe
{
	int parent;
	int id;
} CLASSE;

typedef struct ponto
{
	int x, y;
} PONTO;

typedef struct bloco
{
	int left;
	int right;
	int top;
	int	bottom;
	int width, height;
	unsigned char tipo;
	PONTO esquerdo, direito, cima, baixo, medio, centroide;
	int visitado;
	int perimetro;
	unsigned char pode_remover;
	int vizinho;
} BLOCO;

typedef struct imagem
{
  int width;
  int height;
  TIFF *tif;

  // Raster de 8 bits.
  //unsigned char pixels[MAX_HEIGHT*2][MAX_WIDTH*2];
  unsigned char **pixels;
  //unsigned char rotacionado[MAX_HEIGHT*2][MAX_WIDTH*2];
  unsigned char **rotacionado;

  // Mapeamento dos blocos em cada pixel, ou seja, associa cada pixel a um bloco.
  int *id;

  // Lista dos blocos.
  int total_blocos;
  BLOCO *blocos;
} IMAGEM;


/*****************************************************************************/
/*                                                                           */
/* DESCRIO:                                                                */
/*    Definio da API da biblioteca.                                        */
/*                                                                           */
/*****************************************************************************/


double round(double x);

extern IMAGEM *Abrir(LPSTR lpFileName, double angulo);

extern IMAGEM *Abrir2(LPSTR lpFileName);

extern void Fechar(IMAGEM *imagem, int fechar_tif);

extern void Salvar(IMAGEM *imagem, LPSTR lpFileName);

extern void Salvar2(IMAGEM *imagem, LPSTR lpFileName);